From ffaff02dabf67a619a41c55bef64cb3397e1ddab Mon Sep 17 00:00:00 2001
From: qiaonuohan <qiaonuohan@cn.fujitsu.com>
Date: Fri, 29 Mar 2013 17:46:09 +0800
Subject: [PATCH] fix bug of gdb

---
 gdb-7.3.1.patch |   14 ++++++++------
 1 files changed, 8 insertions(+), 6 deletions(-)

diff --git a/gdb-7.3.1.patch b/gdb-7.3.1.patch
index cd5e678..7ac74de 100644
--- a/gdb-7.3.1.patch
+++ b/gdb-7.3.1.patch
@@ -1823,14 +1823,16 @@ diff -up gdb-7.3.1/gdb/psymtab.c.orig gdb-7.3.1/gdb/psymtab.c
        if (cur_sec == NULL)
 --- gdb-7.3.1/gdb/symtab.c.orig
 +++ gdb-7.3.1/gdb/symtab.c
-@@ -5054,8 +5054,9 @@ gdb_get_datatype(struct gnu_request *req
+@@ -5054,6 +5054,12 @@ gdb_get_datatype(struct gnu_request *req
  		if (gdb_CRASHDEBUG(2))
          		console("expr->elts[0].opcode: OP_VAR_VALUE\n");
  		type = expr->elts[2].symbol->type;
-+		req->typecode = TYPE_CODE(type);
-+		req->length = TYPE_LENGTH(type);
++
++		if (TYPE_CODE(type) == TYPE_CODE_ENUM) {
++			req->typecode = TYPE_CODE(type);
++			req->length = TYPE_LENGTH(type);
++		}
++
  		if (TYPE_CODE(type) == TYPE_CODE_ENUM) {
--			req->typecode = TYPE_CODE(type);
+ 			req->typecode = TYPE_CODE(type);
  			req->value = SYMBOL_VALUE(expr->elts[2].symbol);
- 			req->tagname = TYPE_TAG_NAME(type);
- 			if (!req->tagname) {
-- 
1.7.1

